$PAGEWIDTH=120
;*********************************************************************
;           
;        + 
;    V 1.05 			                       07-12-2009 (28-02-2011)
;---------------------------------------------------------------------

;      
;InitCOM	-  ,      
;		  
;Key		-     " ", 
;		=0 -   , =< > -  ,  
;KeyWait	-    ,   -  
;ScrChar	-    ( )     
;ScrStr	-    ( )  

;      
;.       
;  .
;-      "**",   - 
;-    :
;   "1" -  
;   "2" -  
;   "3" -  
;-         "#4"
;-         "#5"
;*********************************************************************
;
        DefSeg  All,Absolute
        Seg     All
;
;=========================================================
;                
;=========================================================
Reg0	equ		0	;R0
Reg1	equ		1	;R1
Reg4	equ		4	;R4
Steck   equ     7       ; 

Reg_VD	equ		24h ;   (1-,2-,-)

mT50	equ		29h	;  50
mSP1	equ		2Ah	; 1 (  )
mSout	equ		2Bh	;   50

PTA		equ		2Ch	;
PTB		equ		2Dh	;
iBufRs	equ  	2Eh	;   ..
oBufRs	equ		2Fh	; .  .

BufRs	equ		30h	;  (  )
BufRsLng    equ	  24	; 

;=========================================================
;                
;=========================================================
bTxRdy	equ	20h.2	;   
KeyOld	equ	20h.5	;   
			

;=========================================================

;R0 -    
;R1 -      .
;R2 -  (    )
;R3 -  50
;R4 -  50
;R5 -    
;R6 -       
;R7 -    

;=========================================================
;              / 
;=========================================================

Kontr0	equ	P0.2	; (0-) -    !

;               P3.0    ;RxD - in    60
;               P3.1    ;TxD - out   60

Switch	equ	P3.2	;  (=1 / =0)
KeyPin	equ	P3.2	;   -  
Kontr	equ	P3.3	; (1-)

;=========================================================
;                      
;=========================================================

        ORG     0
        LJMP    Begin
;
;	ORG	3		;   INT0
;	
        db      ' trm105 '		; 
;
        ORG     0BH             ;Timer counter TF0 Interrapt
        LJMP    TimInt
;
        ORG     13H             ;pp  INT1 
        reti
;
        ORG     1BH             ;Timer counter TF1 Interrapt
        ljmp	Time50

        ORG     23H             ;  . 
        ljmp	Serial
;
sATZ:	db	'ATZ',0Dh,0	     ; ATZ
sATE0:	db	'ATE0',0Dh,0	     ; -
sATCM:	db	'AT+CMEC=2',0Dh,0    ;  
sATCK:	db	'AT+CKPD=',0	     ;   
sATER:	db	'AT+CMER=3,2,0,0,0',0Dh,0    ;   

AdrOK:	db	'OK',0		;   
AdrErr:	db	'ERROR',0	;   ERROR ()

s_1:	db	'#5',0		;    "#5" 
s_2:	db	'#4',0		;    "#4" 
s2st:	db	'*105*',0	;     "**"

;**********************************************
;       T/C1 (50 )
;**********************************************
Time50:	
		reti
		
;**********************************************
;       T/C0 (25 )
;**********************************************
TimInt: push    ACC
        push    PSW

        MOV     TH0,#8BH    ;  T/C0 = 25
        MOV     TL0,#7AH    ;25 ms  (8B7Ah)  14,31818
                            ;    
		mov		A,PTA		; 
		jz		ti01		; - 
		dec		PTA			; -1  25
ti01:
		dec		PTB			; (50,100,200,400,800,1.6c,3.2c,6.4c)

;  
		mov		A,Reg_VD
		dec		A
		jnz		ti02
		clr		C			;   (1)
		cpl		C
		ajmp	ti04
ti02:	dec		A
		jnz		ti03
		clr		C			;   (2)
		ajmp	ti04
ti03:	mov		A,PTB
		mov		C,ACC.3		; 
		jnb		Switch,ti04
		mov		C,ACC.5		; 
ti04:
		mov		Kontr,C		;  
		cpl		C
		mov		Kontr0,C

		pop     PSW
        pop     ACC
        RETI

;***************************************************
;      
;***************************************************
Serial: push    ACC
        push    PSW

        jnb     RI,ser0     ; 
        clr     RI          ; 

        mov     A,SBUF      ; 

;--      -  "" 
		cjne	A,#' ',ser1	;""
        ajmp    ser2
ser1:	cjne	A,#0Dh,ser3	;<CR>
        ajmp    ser2
ser3:	cjne	A,#0Ah,ser4	;<LF>
        ajmp    ser2
;--  "  "
	
ser4:	lcall	SetBufRs	;  
        ajmp    ser2

ser0:   clr     TI              ; 
		clr		bTxRdy		; 

ser2:   pop     PSW
        pop     ACC
        reti


;******************************************************
;                    
;******************************************************

;------------------------------------------------------
; 50  ( )
;------------------------------------------------------
Pause50: mov	PTA,#2
		ajmp	pa01
;------------------------------------------------------
; 3  ( )
;------------------------------------------------------
Pause3: mov		PTA,#120
		ajmp	pa01
;------------------------------------------------------
; 1  ( )
;------------------------------------------------------
Pause:	mov		PTA,#40
pa01:	mov		A,PTA
		jnz		pa01
		ret

;------------------------------------------------------
; 3        
;( )
;: C=1 -   -   
;       =0 -  
;------------------------------------------------------
Pause3OK: 
		mov		PTA,#120
pa32:	mov		DPTR,#AdrOK	;   ('OK')
		lcall	CompStr		; 
		jc		pa31		;- ,    - 
		jz		pa33		;  - 
pa31:	mov		A,PTA		; 
		jnz		pa32		;  -  
		setb	C			; 
pa33:	ret

;------------------------------------------------------
; 50  (  ) T=0,8
;------------------------------------------------------
Nop50:  mov		R3,#58		;58  -  50
np01:	mov		R4,#0
np02:	nop					;4  256 
		nop					; 858 
		djnz	R4,np02
		djnz	R3,np01
		ret

;------------------------------------------------------
;    ()     
;------------------------------------------------------
SetBufRs:
		mov		R1,iBufRs	; 
		mov		@R1,A		;  ( )
		inc		iBufRs
		mov		R1,iBufRs
		cjne	R1,#(BufRs+BufRsLng),sb1
;   -    ( )
		mov		R1,#(BufRs+1)
sb2:	mov		A,@R1
		dec		R1
		mov		@R1,A
		inc		R1
		inc		R1
		cjne	R1,#(BufRs+BufRsLng+1),sb2
		mov		iBufRs,#(BufRs+BufRsLng-1)	;  

		dec		oBufRs		;  
		mov		R1,oBufRs
		cjne	R1,#(BufRs-1),sb1
		inc		oBufRs	
sb1:	
		ret

;------------------------------------------------------
;        ( )
;  =0,     
;------------------------------------------------------
GetBufRs:
		push	Reg0
		clr		ES		;  .
		mov		R0,oBufRs	; 
		mov		A,@R0
		jz		gb1		;  - 
		inc		oBufRs		; -  
gb1:	
		setb	ES		; 
		pop		Reg0
		ret

;------------------------------------------------------
;    (  
;   ( 0))
;------------------------------------------------------
ResBufRs:
		push	Reg0
		clr		ES				;  .
		mov		iBufRs,#BufRs	;   
		mov		oBufRs,#BufRs	;   
		mov		R0,iBufRs		; 
rb1:	mov		@R0,#0			;0   ( )
		inc		R0
		cjne	R0,#(BufRs+BufRsLng+1),rb1
		setb	ES
		pop		Reg0
		ret

;------------------------------------------------------
;      DPTR   0
;------------------------------------------------------
StrTX:	clr	A
		movc	A,@A+DPTR	;   
		jz		st03		;
		lcall	ByteTX		; 
		inc		DPTR
		ajmp	StrTX		;  - 
st03:	;lcall	ClrBuf		;  	
		ret

;------------------------------------------------------
;  ( )   
;------------------------------------------------------
ByteTX:	jb		bTxRdy,ByteTX	;  
		;       (5 )
		mov		SBUF,A		; 
		setb	bTxRdy		; 
		ret
		
;------------------------------------------------------
;      DPTR   0
;     
;  DPTR      ( )
;------------------------------------------------------
ScrStr:
		push	DPH
		push	DPL
		mov		DPTR,#sATCK	; AT+CKPD= 
		lcall	StrTX		;   AT...
		pop		DPL
		pop		DPH
		lcall	StrTX		;   
		mov		A,#0Dh
		lcall	ByteTX
		lcall	ResBufRs	;  
		lcall	Pause3OK	;  OK  3 
		lcall	Pause50		; 50    
		ret
		
;------------------------------------------------------
;    
;     
;  DPTR      ( )
; :  = 0 -   
;'0'..'9' -   
;'#','*','[',']','S','E' -  #,*,,,,
;'^','V','>','<' -   ,,, 
;------------------------------------------------------
ReadKey:
	mov		DPTR,#k_0	;   ('0')
	lcall	CompStr		; 
	jc		not0		;- ,    - 
	jnz		rk_NO		
	;  - 
	mov		A,#'0'		; "0"
	ret
rk_NO:
	clr		A			; 
	ret
not0:
	mov		DPTR,#k_1	;   ('1')
	lcall	CompStr		; 
	jc		not1		;- ,    - 
	;  - 
	mov		A,#'1'		; "1"
	ret
not1:
	mov		DPTR,#k_2	;   ('2')
	lcall	CompStr		; 
	jc		not2		;- ,    - 
	;  - 
	mov		A,#'2'		; "2"
	ret
not2:
	mov		DPTR,#k_3	;   ('3')
	lcall	CompStr		; 
	jc		not3		;- ,    - 
	;  - 
	mov		A,#'3'		; "3"
	ret
not3:
	mov		DPTR,#k_4	;   ('4')
	lcall	CompStr		; 
	jc		not4		;- ,    - 
	;  - 
	mov		A,#'4'		; "4"
	ret
not4:
	mov		DPTR,#k_5	;   ('5')
	lcall	CompStr		; 
	jc		not5		;- ,    - 
	;  - 
	mov		A,#'5'		; "5"
	ret
not5:
	mov		DPTR,#k_6	;   ('6')
	lcall	CompStr		; 
	jc		not6		;- ,    - 
	;  - 
	mov		A,#'6'		; "6"
	ret
not6:
	mov		DPTR,#k_7	;   ('7')
	lcall	CompStr		; 
	jc		not7		;- ,    - 
	;  - 
	mov		A,#'7'		; "7"
	ret
not7:
	mov		DPTR,#k_8	;   ('8')
	lcall	CompStr		; 
	jc		not8		;- ,    - 
	;  - 
	mov		A,#'8'		; "8"
	ret
not8:
	mov		DPTR,#k_9	;   ('9')
	lcall	CompStr		; 
	jc		not9		;- ,    - 
	;  - 
	mov		A,#'9'		; "9"
	ret
not9:
	mov		DPTR,#k_str	;   ('*')
	lcall	CompStr		; 
	jc		notstr		;- ,    - 
	;  - 
	mov		A,#'*'		; "*"
	ret
notstr:
	mov		DPTR,#k_dez	;   ('#')
	lcall	CompStr		; 
	jc		notdez		;- ,    - 
	;  - 
	mov		A,#'#'		; "#"
	ret
notdez:
	clr		A			; 
	ret

k_0:	db	'+CKEV:"0",1',0	; "0"
k_1:	db	'+CKEV:"1",1',0	; "1"
k_2:	db	'+CKEV:"2",1',0	; "2"
k_3:	db	'+CKEV:"3",1',0	; "3"
k_4:	db	'+CKEV:"4",1',0	; "4"
k_5:	db	'+CKEV:"5",1',0	; "5"
k_6:	db	'+CKEV:"6",1',0	; "6"
k_7:	db	'+CKEV:"7",1',0	; "7"
k_8:	db	'+CKEV:"8",1',0	; "8"
k_9:	db	'+CKEV:"9",1',0	; "9"
k_str:	db	'+CKEV:"*",1',0	; "*"
k_dez:	db	'+CKEV:"#",1',0	; "#"
		
;------------------------------------------------------
;  ( ,   )
;:  DPTR -      (0-)
;: C=1      - - ,   
;	=0,=0  -   (R0 . .)
;	=0,<>0 -   (  )
;------------------------------------------------------
CompStr: 
		mov		R0,#BufRs	; 
CompStrR0:					;     R0
		mov		R3,#0		;    
cs01:	mov		A,@R0		;   
		jz		cs02		;  (0) - 
		mov		A,R3
		movc	A,@A+DPTR	;   
		xrl		A,@R0		;   
		jnz		cs03		; 
		inc		R3			; -  
		mov		A,R3
		movc	A,@A+DPTR	;    ( 0 - )
		clr		C			; 
		jz		cs04		; - 
		inc		R0			;   
		ajmp	cs01		;
cs03:	inc		R0			;   
		mov		R3,#0		;     
		ajmp	cs01		;
cs02:	mov		A,R0		;,    
		add		A,#(-BufRs-1)	;   (R0>BufSR)
cs04:	ret

;******************************************************
;                  
;******************************************************
Begin:  mov     SP,#Steck       ; 
;-------------   -------------
        mov     SCON,#01110000b ;    1
;-------------  ------------
        MOV     TMOD,#00100001b ;  :
        ;T/C0:      TR0
        ;      16  /
        ;T/C1:      TR1
        ;      8   /
	;         . 1200
	;           52 
        mov     TH1,#194        ;  52 
        mov     TL1,#194		;14.3
		mov		PCON,#10000000b	;SMOD=1
        MOV     TH0,#8BH        ;  T/C0 = 25
        MOV     TL0,#7AH        ;25 ms  (8B7Ah)  14,31818
		mov		PTB,#1			;  -    
        SETB    TR1             ; T/C1
        SETB    TR0             ; T/C0
        SETB    PT1             ; T/C1
        MOV     IE,#00011010b   ;   T/C0  /1  .

		clr		bTxRdy			;  ()
		lcall	ResBufRs		;  
		
	mov		Reg_VD,#2	; 
    SETB    EA          ; 
;
;==============================================================
;     ATZ      
	mov		DPTR,#sATZ	; ATZ (     )
	lcall	StrTX		;   ATZ
	lcall	ResBufRs	;  
	lcall	Pause3		;  3 
	
;==============================================================
;  -  :    ATZ      
	mov		DPTR,#sATZ	; ATZ (     )
	lcall	StrTX		;   ATZ
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	jc		bg			; ,   -  
	lcall	Pause50		; 50    
	
;==============================================================
;   ATE0   -
	mov		DPTR,#sATE0	; ATE0 
	lcall	StrTX		;   AT...
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	lcall	Pause50		; 50    
				;   	
;==============================================================
;   AT+CMEC=2	;  
	mov		DPTR,#sATCM	; AT+CMEC=2 
	lcall	StrTX		;   AT...
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	lcall	Pause50		; 50    
				;   	
;==============================================================
;   AT+CMER=3,2,0,0,0	;   
	mov		DPTR,#sATER	; AT+CMER=3,2,0,0,0 
	lcall	StrTX		;   AT...
	lcall	ResBufRs	;  
	lcall	Pause3OK	;  OK  3 
	lcall	Pause50		; 50    
				;   	
bg:
;   
; 
;  
	mov		Reg_VD,#3	; 
;     "**"
	mov		DPTR,#s2st	;   
	lcall	ScrStr		;   
	
cyr:					;  
;    
	jnb		KeyPin,c_pr	; 
	jb		KeyOld,c_en	;   -  
	;  
	setb 	KeyOld		;  
	mov		DPTR,#s_1	; "#5" 
	lcall	ScrStr		;   
	ajmp	c_en
	
c_pr:
	jnb		KeyOld,c_en	;   - 
	;  
	clr 	KeyOld		;  
	mov		DPTR,#s_2	; "#4" 
	lcall	ScrStr		;   
	
c_en:
;    
	lcall	ReadKey		;    
	
	cjne	A,#'1',c_k1	;  "1" -  
	mov		Reg_VD,#1	; 
	ajmp	c_k3
	
c_k1:	
	cjne	A,#'2',c_k2	;  "2" -  
	mov		Reg_VD,#2	; 
	ajmp	c_k3
	
c_k2:	
	cjne	A,#'3',c_k4	;  "3" -  
	mov		Reg_VD,#3	; 

c_k3:
	lcall	ResBufRs	;  
c_k4:
	ljmp	cyr
	
        END
;
